clear all
close all
clc

% define system
s = tf('s');
sys = 1/(1+s)^3;
% sys = 1/(1+20*s)*exp(-5*s); % Per l'esempio su extremum seeking
% sys = 1/(1+20*s)*exp(-20*s);
% sys = 1/(1+10*s)^8;
% sys = (1-5*s)/((1+10*s)*(1+20*s));

% nyquist plot
figure()
nyquist(sys);

% init controller and NL
U = 1;
Kp = 0;
Ki = 0;
Kd = 0;

open('simscheme')


return
%% Retrieve parameters
tol = 1e-9;
E = (max(simOutput.signals.values) - min(simOutput.signals.values))/2;
ii = find(abs(diff(simOutput.signals.values))<tol);
T = (simOutput.time(ii(end)) - simOutput.time(ii(end-2)));
Kp_crit = 4*U/pi/E; % Guadagno critico
omega = 2*pi/T; % pulsazione


% Plot
figure
plot(simOutput.time, simOutput.signals.values)
hold on
plot(simOutput.time(ii(end-2)),simOutput.signals.values(ii(end-2)),'ro')
plot(simOutput.time(ii(end)),simOutput.signals.values(ii(end)),'ro')


%% Compute regulator parameters
choice = 'PID'
switch choice
    case 'P'
        Kp = 0.5*Kp_crit;
        Ki = 0;
        Kd = 0;
    case 'PI'
        Kp = 0.45*Kp_crit;
        Ti = 0.8*T;
        Ki = Kp/Ti;
        Kd = 0;
    case 'PID'
        Kp = 0.6*Kp_crit;
        Ti = 0.5*T;
        Td = 0.125*T;
        Ki = Kp/Ti;
        Kd = Kp*Td;
end
